Merge tag 'v2.14.1'
[git/raj.git] / git-rebase--interactive.sh
blob90b1fbe9cf6e8dfb2f4331916809fa40bf9050d2
1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode. "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
5 # Copyright (c) 2006 Johannes E. Schindelin
7 # The original idea comes from Eric W. Biederman, in
8 # https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user. As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo="$state_dir"/git-rebase-todo
16 # The rebase command lines that have already been processed. A line
17 # is moved here when it is first handled, before any associated user
18 # actions.
19 done="$state_dir"/done
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg="$state_dir"/message
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands. When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it. The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
32 # The first line of the file is of the form
33 # # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated. It is deleted just before the combined commit is made.
38 squash_msg="$state_dir"/message-squash
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit. (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg="$state_dir"/message-fixup
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be. This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
52 # example.)
53 rewritten="$state_dir"/rewritten
55 dropped="$state_dir"/dropped
57 end="$state_dir"/end
58 msgnum="$state_dir"/msgnum
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
62 # being rebased.
63 author_script="$state_dir"/author-script
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file. When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited. When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s. The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
80 # Work around Git for Windows' Bash whose "read" does not strip CRLF
81 # and leaves CR at the end instead.
82 cr=$(printf "\015")
84 strategy_args=${strategy:+--strategy=$strategy}
85 test -n "$strategy_opts" &&
86 eval '
87 for strategy_opt in '"$strategy_opts"'
89 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
90 done
93 GIT_CHERRY_PICK_HELP="$resolvemsg"
94 export GIT_CHERRY_PICK_HELP
96 comment_char=$(git config --get core.commentchar 2>/dev/null)
97 case "$comment_char" in
98 '' | auto)
99 comment_char="#"
104 comment_char=$(echo "$comment_char" | cut -c1)
106 esac
108 warn () {
109 printf '%s\n' "$*" >&2
112 # Output the commit message for the specified commit.
113 commit_message () {
114 git cat-file commit "$1" | sed "1,/^$/d"
117 orig_reflog_action="$GIT_REFLOG_ACTION"
119 comment_for_reflog () {
120 case "$orig_reflog_action" in
121 ''|rebase*)
122 GIT_REFLOG_ACTION="rebase -i ($1)"
123 export GIT_REFLOG_ACTION
125 esac
128 last_count=
129 mark_action_done () {
130 sed -e 1q < "$todo" >> "$done"
131 sed -e 1d < "$todo" >> "$todo".new
132 mv -f "$todo".new "$todo"
133 new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
134 echo $new_count >"$msgnum"
135 total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
136 echo $total >"$end"
137 if test "$last_count" != "$new_count"
138 then
139 last_count=$new_count
140 eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
141 test -z "$verbose" || echo
145 # Put the last action marked done at the beginning of the todo list
146 # again. If there has not been an action marked done yet, leave the list of
147 # items on the todo list unchanged.
148 reschedule_last_action () {
149 tail -n 1 "$done" | cat - "$todo" >"$todo".new
150 sed -e \$d <"$done" >"$done".new
151 mv -f "$todo".new "$todo"
152 mv -f "$done".new "$done"
155 append_todo_help () {
156 gettext "
157 Commands:
158 p, pick = use commit
159 r, reword = use commit, but edit the commit message
160 e, edit = use commit, but stop for amending
161 s, squash = use commit, but meld into previous commit
162 f, fixup = like \"squash\", but discard this commit's log message
163 x, exec = run command (the rest of the line) using shell
164 d, drop = remove commit
166 These lines can be re-ordered; they are executed from top to bottom.
167 " | git stripspace --comment-lines >>"$todo"
169 if test $(get_missing_commit_check_level) = error
170 then
171 gettext "
172 Do not remove any line. Use 'drop' explicitly to remove a commit.
173 " | git stripspace --comment-lines >>"$todo"
174 else
175 gettext "
176 If you remove a line here THAT COMMIT WILL BE LOST.
177 " | git stripspace --comment-lines >>"$todo"
181 make_patch () {
182 sha1_and_parents="$(git rev-list --parents -1 "$1")"
183 case "$sha1_and_parents" in
184 ?*' '?*' '?*)
185 git diff --cc $sha1_and_parents
187 ?*' '?*)
188 git diff-tree -p "$1^!"
191 echo "Root commit"
193 esac > "$state_dir"/patch
194 test -f "$msg" ||
195 commit_message "$1" > "$msg"
196 test -f "$author_script" ||
197 get_author_ident_from_commit "$1" > "$author_script"
200 die_with_patch () {
201 echo "$1" > "$state_dir"/stopped-sha
202 make_patch "$1"
203 die "$2"
206 exit_with_patch () {
207 echo "$1" > "$state_dir"/stopped-sha
208 make_patch $1
209 git rev-parse --verify HEAD > "$amend"
210 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
211 warn "$(eval_gettext "\
212 You can amend the commit now, with
214 git commit --amend \$gpg_sign_opt_quoted
216 Once you are satisfied with your changes, run
218 git rebase --continue")"
219 warn
220 exit $2
223 die_abort () {
224 apply_autostash
225 rm -rf "$state_dir"
226 die "$1"
229 has_action () {
230 test -n "$(git stripspace --strip-comments <"$1")"
233 is_empty_commit() {
234 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
235 sha1=$1
236 die "$(eval_gettext "\$sha1: not a commit that can be picked")"
238 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
239 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
240 test "$tree" = "$ptree"
243 is_merge_commit()
245 git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
248 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
249 # GIT_AUTHOR_DATE exported from the current environment.
250 do_with_author () {
252 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
253 "$@"
257 git_sequence_editor () {
258 if test -z "$GIT_SEQUENCE_EDITOR"
259 then
260 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
261 if [ -z "$GIT_SEQUENCE_EDITOR" ]
262 then
263 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
267 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
270 pick_one () {
271 ff=--ff
273 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
274 case "$force_rebase" in '') ;; ?*) ff= ;; esac
275 output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
277 if is_empty_commit "$sha1"
278 then
279 empty_args="--allow-empty"
282 test -d "$rewritten" &&
283 pick_one_preserving_merges "$@" && return
284 output eval git cherry-pick \
285 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
286 "$strategy_args" $empty_args $ff "$@"
288 # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
289 # previous task so this commit is not lost.
290 ret=$?
291 case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
292 return $ret
295 pick_one_preserving_merges () {
296 fast_forward=t
297 case "$1" in
299 fast_forward=f
300 sha1=$2
303 sha1=$1
305 esac
306 sha1=$(git rev-parse $sha1)
308 if test -f "$state_dir"/current-commit
309 then
310 if test "$fast_forward" = t
311 then
312 while read current_commit
314 git rev-parse HEAD > "$rewritten"/$current_commit
315 done <"$state_dir"/current-commit
316 rm "$state_dir"/current-commit ||
317 die "$(gettext "Cannot write current commit's replacement sha1")"
321 echo $sha1 >> "$state_dir"/current-commit
323 # rewrite parents; if none were rewritten, we can fast-forward.
324 new_parents=
325 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
326 if test "$pend" = " "
327 then
328 pend=" root"
330 while [ "$pend" != "" ]
332 p=$(expr "$pend" : ' \([^ ]*\)')
333 pend="${pend# $p}"
335 if test -f "$rewritten"/$p
336 then
337 new_p=$(cat "$rewritten"/$p)
339 # If the todo reordered commits, and our parent is marked for
340 # rewriting, but hasn't been gotten to yet, assume the user meant to
341 # drop it on top of the current HEAD
342 if test -z "$new_p"
343 then
344 new_p=$(git rev-parse HEAD)
347 test $p != $new_p && fast_forward=f
348 case "$new_parents" in
349 *$new_p*)
350 ;; # do nothing; that parent is already there
352 new_parents="$new_parents $new_p"
354 esac
355 else
356 if test -f "$dropped"/$p
357 then
358 fast_forward=f
359 replacement="$(cat "$dropped"/$p)"
360 test -z "$replacement" && replacement=root
361 pend=" $replacement$pend"
362 else
363 new_parents="$new_parents $p"
366 done
367 case $fast_forward in
369 output warn "$(eval_gettext "Fast-forward to \$sha1")"
370 output git reset --hard $sha1 ||
371 die "$(eval_gettext "Cannot fast-forward to \$sha1")"
374 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
376 if [ "$1" != "-n" ]
377 then
378 # detach HEAD to current parent
379 output git checkout $first_parent 2> /dev/null ||
380 die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
383 case "$new_parents" in
384 ' '*' '*)
385 test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
387 # redo merge
388 author_script_content=$(get_author_ident_from_commit $sha1)
389 eval "$author_script_content"
390 msg_content="$(commit_message $sha1)"
391 # No point in merging the first parent, that's HEAD
392 new_parents=${new_parents# $first_parent}
393 merge_args="--no-log --no-ff"
394 if ! do_with_author output eval \
395 'git merge ${gpg_sign_opt:+"$gpg_sign_opt"} \
396 $merge_args $strategy_args -m "$msg_content" $new_parents'
397 then
398 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
399 die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
401 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
404 output eval git cherry-pick \
405 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
406 "$strategy_args" "$@" ||
407 die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
409 esac
411 esac
414 this_nth_commit_message () {
415 n=$1
416 eval_gettext "This is the commit message #\${n}:"
419 skip_nth_commit_message () {
420 n=$1
421 eval_gettext "The commit message #\${n} will be skipped:"
424 update_squash_messages () {
425 if test -f "$squash_msg"; then
426 mv "$squash_msg" "$squash_msg".bak || exit
427 count=$(($(sed -n \
428 -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
429 -e "q" < "$squash_msg".bak)+1))
431 printf '%s\n' "$comment_char $(eval_ngettext \
432 "This is a combination of \$count commit." \
433 "This is a combination of \$count commits." \
434 $count)"
435 sed -e 1d -e '2,/^./{
436 /^$/d
437 }' <"$squash_msg".bak
438 } >"$squash_msg"
439 else
440 commit_message HEAD >"$fixup_msg" ||
441 die "$(eval_gettext "Cannot write \$fixup_msg")"
442 count=2
444 printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
445 printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
446 echo
447 cat "$fixup_msg"
448 } >"$squash_msg"
450 case $1 in
451 squash)
452 rm -f "$fixup_msg"
453 echo
454 printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
455 echo
456 commit_message $2
458 fixup)
459 echo
460 printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
461 echo
462 # Change the space after the comment character to TAB:
463 commit_message $2 | git stripspace --comment-lines | sed -e 's/ / /'
465 esac >>"$squash_msg"
468 peek_next_command () {
469 git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
472 # A squash/fixup has failed. Prepare the long version of the squash
473 # commit message, then die_with_patch. This code path requires the
474 # user to edit the combined commit message for all commits that have
475 # been squashed/fixedup so far. So also erase the old squash
476 # messages, effectively causing the combined commit to be used as the
477 # new basis for any further squash/fixups. Args: sha1 rest
478 die_failed_squash() {
479 sha1=$1
480 rest=$2
481 mv "$squash_msg" "$msg" || exit
482 rm -f "$fixup_msg"
483 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
484 warn
485 warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
486 die_with_patch $sha1 ""
489 flush_rewritten_pending() {
490 test -s "$rewritten_pending" || return
491 newsha1="$(git rev-parse HEAD^0)"
492 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
493 rm -f "$rewritten_pending"
496 record_in_rewritten() {
497 oldsha1="$(git rev-parse $1)"
498 echo "$oldsha1" >> "$rewritten_pending"
500 case "$(peek_next_command)" in
501 squash|s|fixup|f)
504 flush_rewritten_pending
506 esac
509 do_pick () {
510 sha1=$1
511 rest=$2
512 if test "$(git rev-parse HEAD)" = "$squash_onto"
513 then
514 # Set the correct commit message and author info on the
515 # sentinel root before cherry-picking the original changes
516 # without committing (-n). Finally, update the sentinel again
517 # to include these changes. If the cherry-pick results in a
518 # conflict, this means our behaviour is similar to a standard
519 # failed cherry-pick during rebase, with a dirty index to
520 # resolve before manually running git commit --amend then git
521 # rebase --continue.
522 git commit --allow-empty --allow-empty-message --amend \
523 --no-post-rewrite -n -q -C $sha1 &&
524 pick_one -n $sha1 &&
525 git commit --allow-empty --allow-empty-message \
526 --amend --no-post-rewrite -n -q -C $sha1 \
527 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
528 die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
529 else
530 pick_one $sha1 ||
531 die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
535 do_next () {
536 rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
537 read -r command sha1 rest < "$todo"
538 case "$command" in
539 "$comment_char"*|''|noop|drop|d)
540 mark_action_done
542 "$cr")
543 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
544 mark_action_done
546 pick|p)
547 comment_for_reflog pick
549 mark_action_done
550 do_pick $sha1 "$rest"
551 record_in_rewritten $sha1
553 reword|r)
554 comment_for_reflog reword
556 mark_action_done
557 do_pick $sha1 "$rest"
558 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
559 warn "$(eval_gettext "\
560 Could not amend commit after successfully picking \$sha1... \$rest
561 This is most likely due to an empty commit message, or the pre-commit hook
562 failed. If the pre-commit hook failed, you may need to resolve the issue before
563 you are able to reword the commit.")"
564 exit_with_patch $sha1 1
566 record_in_rewritten $sha1
568 edit|e)
569 comment_for_reflog edit
571 mark_action_done
572 do_pick $sha1 "$rest"
573 sha1_abbrev=$(git rev-parse --short $sha1)
574 warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
575 exit_with_patch $sha1 0
577 squash|s|fixup|f)
578 case "$command" in
579 squash|s)
580 squash_style=squash
582 fixup|f)
583 squash_style=fixup
585 esac
586 comment_for_reflog $squash_style
588 test -f "$done" && has_action "$done" ||
589 die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
591 mark_action_done
592 update_squash_messages $squash_style $sha1
593 author_script_content=$(get_author_ident_from_commit HEAD)
594 echo "$author_script_content" > "$author_script"
595 eval "$author_script_content"
596 if ! pick_one -n $sha1
597 then
598 git rev-parse --verify HEAD >"$amend"
599 die_failed_squash $sha1 "$rest"
601 case "$(peek_next_command)" in
602 squash|s|fixup|f)
603 # This is an intermediate commit; its message will only be
604 # used in case of trouble. So use the long version:
605 do_with_author output git commit --amend --no-verify -F "$squash_msg" \
606 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
607 die_failed_squash $sha1 "$rest"
610 # This is the final command of this squash/fixup group
611 if test -f "$fixup_msg"
612 then
613 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
614 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
615 die_failed_squash $sha1 "$rest"
616 else
617 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
618 rm -f "$GIT_DIR"/MERGE_MSG
619 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
620 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
621 die_failed_squash $sha1 "$rest"
623 rm -f "$squash_msg" "$fixup_msg"
625 esac
626 record_in_rewritten $sha1
628 x|"exec")
629 read -r command rest < "$todo"
630 mark_action_done
631 eval_gettextln "Executing: \$rest"
632 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
633 status=$?
634 # Run in subshell because require_clean_work_tree can die.
635 dirty=f
636 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
637 if test "$status" -ne 0
638 then
639 warn "$(eval_gettext "Execution failed: \$rest")"
640 test "$dirty" = f ||
641 warn "$(gettext "and made changes to the index and/or the working tree")"
643 warn "$(gettext "\
644 You can fix the problem, and then run
646 git rebase --continue")"
647 warn
648 if test $status -eq 127 # command not found
649 then
650 status=1
652 exit "$status"
653 elif test "$dirty" = t
654 then
655 # TRANSLATORS: after these lines is a command to be issued by the user
656 warn "$(eval_gettext "\
657 Execution succeeded: \$rest
658 but left changes to the index and/or the working tree
659 Commit or stash your changes, and then run
661 git rebase --continue")"
662 warn
663 exit 1
667 warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
668 fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
669 if git rev-parse --verify -q "$sha1" >/dev/null
670 then
671 die_with_patch $sha1 "$fixtodo"
672 else
673 die "$fixtodo"
676 esac
677 test -s "$todo" && return
679 comment_for_reflog finish &&
680 newhead=$(git rev-parse HEAD) &&
681 case $head_name in
682 refs/*)
683 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
684 git update-ref -m "$message" $head_name $newhead $orig_head &&
685 git symbolic-ref \
686 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
687 HEAD $head_name
689 esac && {
690 test ! -f "$state_dir"/verbose ||
691 git diff-tree --stat $orig_head..HEAD
692 } &&
694 test -s "$rewritten_list" &&
695 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
696 true # we don't care if this copying failed
697 } &&
698 hook="$(git rev-parse --git-path hooks/post-rewrite)"
699 if test -x "$hook" && test -s "$rewritten_list"; then
700 "$hook" rebase < "$rewritten_list"
701 true # we don't care if this hook failed
702 fi &&
703 warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
705 return 1 # not failure; just to break the do_rest loop
708 # can only return 0, when the infinite loop breaks
709 do_rest () {
710 while :
712 do_next || break
713 done
716 # skip picking commits whose parents are unchanged
717 skip_unnecessary_picks () {
718 fd=3
719 while read -r command rest
721 # fd=3 means we skip the command
722 case "$fd,$command" in
723 3,pick|3,p)
724 # pick a commit whose parent is current $onto -> skip
725 sha1=${rest%% *}
726 case "$(git rev-parse --verify --quiet "$sha1"^)" in
727 "$onto"*)
728 onto=$sha1
731 fd=1
733 esac
735 3,"$comment_char"*|3,)
736 # copy comments
739 fd=1
741 esac
742 printf '%s\n' "$command${rest:+ }$rest" >&$fd
743 done <"$todo" >"$todo.new" 3>>"$done" &&
744 mv -f "$todo".new "$todo" &&
745 case "$(peek_next_command)" in
746 squash|s|fixup|f)
747 record_in_rewritten "$onto"
749 esac ||
750 die "$(gettext "Could not skip unnecessary pick commands")"
753 transform_todo_ids () {
754 while read -r command rest
756 case "$command" in
757 "$comment_char"* | exec)
758 # Be careful for oddball commands like 'exec'
759 # that do not have a SHA-1 at the beginning of $rest.
762 sha1=$(git rev-parse --verify --quiet "$@" ${rest%%[ ]*}) &&
763 rest="$sha1 ${rest#*[ ]}"
765 esac
766 printf '%s\n' "$command${rest:+ }$rest"
767 done <"$todo" >"$todo.new" &&
768 mv -f "$todo.new" "$todo"
771 expand_todo_ids() {
772 transform_todo_ids
775 collapse_todo_ids() {
776 transform_todo_ids --short
779 # Rearrange the todo list that has both "pick sha1 msg" and
780 # "pick sha1 fixup!/squash! msg" appears in it so that the latter
781 # comes immediately after the former, and change "pick" to
782 # "fixup"/"squash".
784 # Note that if the config has specified a custom instruction format
785 # each log message will be re-retrieved in order to normalize the
786 # autosquash arrangement
787 rearrange_squash () {
788 # extract fixup!/squash! lines and resolve any referenced sha1's
789 while read -r pick sha1 message
791 test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
792 case "$message" in
793 "squash! "*|"fixup! "*)
794 action="${message%%!*}"
795 rest=$message
796 prefix=
797 # skip all squash! or fixup! (but save for later)
798 while :
800 case "$rest" in
801 "squash! "*|"fixup! "*)
802 prefix="$prefix${rest%%!*},"
803 rest="${rest#*! }"
806 break
808 esac
809 done
810 printf '%s %s %s %s\n' "$sha1" "$action" "$prefix" "$rest"
811 # if it's a single word, try to resolve to a full sha1 and
812 # emit a second copy. This allows us to match on both message
813 # and on sha1 prefix
814 if test "${rest#* }" = "$rest"; then
815 fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
816 if test -n "$fullsha"; then
817 # prefix the action to uniquely identify this line as
818 # intended for full sha1 match
819 echo "$sha1 +$action $prefix $fullsha"
822 esac
823 done >"$1.sq" <"$1"
824 test -s "$1.sq" || return
826 used=
827 while read -r pick sha1 message
829 case " $used" in
830 *" $sha1 "*) continue ;;
831 esac
832 printf '%s\n' "$pick $sha1 $message"
833 test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
834 used="$used$sha1 "
835 while read -r squash action msg_prefix msg_content
837 case " $used" in
838 *" $squash "*) continue ;;
839 esac
840 emit=0
841 case "$action" in
843 action="${action#+}"
844 # full sha1 prefix test
845 case "$msg_content" in "$sha1"*) emit=1;; esac ;;
847 # message prefix test
848 case "$message" in "$msg_content"*) emit=1;; esac ;;
849 esac
850 if test $emit = 1; then
851 if test -n "${format}"
852 then
853 msg_content=$(git log -n 1 --format="${format}" ${squash})
854 else
855 msg_content="$(echo "$msg_prefix" | sed "s/,/! /g")$msg_content"
857 printf '%s\n' "$action $squash $msg_content"
858 used="$used$squash "
860 done <"$1.sq"
861 done >"$1.rearranged" <"$1"
862 cat "$1.rearranged" >"$1"
863 rm -f "$1.sq" "$1.rearranged"
866 # Add commands after a pick or after a squash/fixup serie
867 # in the todo list.
868 add_exec_commands () {
870 first=t
871 while read -r insn rest
873 case $insn in
874 pick)
875 test -n "$first" ||
876 printf "%s" "$cmd"
878 esac
879 printf "%s %s\n" "$insn" "$rest"
880 first=
881 done
882 printf "%s" "$cmd"
883 } <"$1" >"$1.new" &&
884 mv "$1.new" "$1"
887 # Check if the SHA-1 passed as an argument is a
888 # correct one, if not then print $2 in "$todo".badsha
889 # $1: the SHA-1 to test
890 # $2: the line number of the input
891 # $3: the input filename
892 check_commit_sha () {
893 badsha=0
894 if test -z "$1"
895 then
896 badsha=1
897 else
898 sha1_verif="$(git rev-parse --verify --quiet $1^{commit})"
899 if test -z "$sha1_verif"
900 then
901 badsha=1
905 if test $badsha -ne 0
906 then
907 line="$(sed -n -e "${2}p" "$3")"
908 warn "$(eval_gettext "\
909 Warning: the SHA-1 is missing or isn't a commit in the following line:
910 - \$line")"
911 warn
914 return $badsha
917 # prints the bad commits and bad commands
918 # from the todolist in stdin
919 check_bad_cmd_and_sha () {
920 retval=0
921 lineno=0
922 while read -r command rest
924 lineno=$(( $lineno + 1 ))
925 case $command in
926 "$comment_char"*|''|noop|x|exec)
927 # Doesn't expect a SHA-1
929 "$cr")
930 # Work around CR left by "read" (e.g. with Git for
931 # Windows' Bash).
933 pick|p|drop|d|reword|r|edit|e|squash|s|fixup|f)
934 if ! check_commit_sha "${rest%%[ ]*}" "$lineno" "$1"
935 then
936 retval=1
940 line="$(sed -n -e "${lineno}p" "$1")"
941 warn "$(eval_gettext "\
942 Warning: the command isn't recognized in the following line:
943 - \$line")"
944 warn
945 retval=1
947 esac
948 done <"$1"
949 return $retval
952 # Print the list of the SHA-1 of the commits
953 # from stdin to stdout
954 todo_list_to_sha_list () {
955 git stripspace --strip-comments |
956 while read -r command sha1 rest
958 case $command in
959 "$comment_char"*|''|noop|x|"exec")
962 long_sha=$(git rev-list --no-walk "$sha1" 2>/dev/null)
963 printf "%s\n" "$long_sha"
965 esac
966 done
969 # Use warn for each line in stdin
970 warn_lines () {
971 while read -r line
973 warn " - $line"
974 done
977 # Switch to the branch in $into and notify it in the reflog
978 checkout_onto () {
979 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
980 output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
981 git update-ref ORIG_HEAD $orig_head
984 get_missing_commit_check_level () {
985 check_level=$(git config --get rebase.missingCommitsCheck)
986 check_level=${check_level:-ignore}
987 # Don't be case sensitive
988 printf '%s' "$check_level" | tr 'A-Z' 'a-z'
991 # Check if the user dropped some commits by mistake
992 # Behaviour determined by rebase.missingCommitsCheck.
993 # Check if there is an unrecognized command or a
994 # bad SHA-1 in a command.
995 check_todo_list () {
996 raise_error=f
998 check_level=$(get_missing_commit_check_level)
1000 case "$check_level" in
1001 warn|error)
1002 # Get the SHA-1 of the commits
1003 todo_list_to_sha_list <"$todo".backup >"$todo".oldsha1
1004 todo_list_to_sha_list <"$todo" >"$todo".newsha1
1006 # Sort the SHA-1 and compare them
1007 sort -u "$todo".oldsha1 >"$todo".oldsha1+
1008 mv "$todo".oldsha1+ "$todo".oldsha1
1009 sort -u "$todo".newsha1 >"$todo".newsha1+
1010 mv "$todo".newsha1+ "$todo".newsha1
1011 comm -2 -3 "$todo".oldsha1 "$todo".newsha1 >"$todo".miss
1013 # Warn about missing commits
1014 if test -s "$todo".miss
1015 then
1016 test "$check_level" = error && raise_error=t
1018 warn "$(gettext "\
1019 Warning: some commits may have been dropped accidentally.
1020 Dropped commits (newer to older):")"
1022 # Make the list user-friendly and display
1023 opt="--no-walk=sorted --format=oneline --abbrev-commit --stdin"
1024 git rev-list $opt <"$todo".miss | warn_lines
1026 warn "$(gettext "\
1027 To avoid this message, use \"drop\" to explicitly remove a commit.
1029 Use 'git config rebase.missingCommitsCheck' to change the level of warnings.
1030 The possible behaviours are: ignore, warn, error.")"
1031 warn
1034 ignore)
1037 warn "$(eval_gettext "Unrecognized setting \$check_level for option rebase.missingCommitsCheck. Ignoring.")"
1039 esac
1041 if ! check_bad_cmd_and_sha "$todo"
1042 then
1043 raise_error=t
1046 if test $raise_error = t
1047 then
1048 # Checkout before the first commit of the
1049 # rebase: this way git rebase --continue
1050 # will work correctly as it expects HEAD to be
1051 # placed before the commit of the next action
1052 checkout_onto
1054 warn "$(gettext "You can fix this with 'git rebase --edit-todo' and then run 'git rebase --continue'.")"
1055 die "$(gettext "Or you can abort the rebase with 'git rebase --abort'.")"
1059 # The whole contents of this file is run by dot-sourcing it from
1060 # inside a shell function. It used to be that "return"s we see
1061 # below were not inside any function, and expected to return
1062 # to the function that dot-sourced us.
1064 # However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
1065 # construct and continue to run the statements that follow such a "return".
1066 # As a work-around, we introduce an extra layer of a function
1067 # here, and immediately call it after defining it.
1068 git_rebase__interactive () {
1070 case "$action" in
1071 continue)
1072 if test ! -d "$rewritten"
1073 then
1074 exec git rebase--helper ${force_rebase:+--no-ff} --continue
1076 # do we have anything to commit?
1077 if git diff-index --cached --quiet HEAD --
1078 then
1079 # Nothing to commit -- skip this commit
1081 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
1082 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
1083 die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
1084 else
1085 if ! test -f "$author_script"
1086 then
1087 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
1088 die "$(eval_gettext "\
1089 You have staged changes in your working tree.
1090 If these changes are meant to be
1091 squashed into the previous commit, run:
1093 git commit --amend \$gpg_sign_opt_quoted
1095 If they are meant to go into a new commit, run:
1097 git commit \$gpg_sign_opt_quoted
1099 In both cases, once you're done, continue with:
1101 git rebase --continue
1104 . "$author_script" ||
1105 die "$(gettext "Error trying to find the author identity to amend commit")"
1106 if test -f "$amend"
1107 then
1108 current_head=$(git rev-parse --verify HEAD)
1109 test "$current_head" = $(cat "$amend") ||
1110 die "$(gettext "\
1111 You have uncommitted changes in your working tree. Please commit them
1112 first and then run 'git rebase --continue' again.")"
1113 do_with_author git commit --amend --no-verify -F "$msg" -e \
1114 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1115 die "$(gettext "Could not commit staged changes.")"
1116 else
1117 do_with_author git commit --no-verify -F "$msg" -e \
1118 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1119 die "$(gettext "Could not commit staged changes.")"
1123 if test -r "$state_dir"/stopped-sha
1124 then
1125 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
1128 require_clean_work_tree "rebase"
1129 do_rest
1130 return 0
1132 skip)
1133 git rerere clear
1135 if test ! -d "$rewritten"
1136 then
1137 exec git rebase--helper ${force_rebase:+--no-ff} --continue
1139 do_rest
1140 return 0
1142 edit-todo)
1143 git stripspace --strip-comments <"$todo" >"$todo".new
1144 mv -f "$todo".new "$todo"
1145 collapse_todo_ids
1146 append_todo_help
1147 gettext "
1148 You are editing the todo file of an ongoing interactive rebase.
1149 To continue rebase after editing, run:
1150 git rebase --continue
1152 " | git stripspace --comment-lines >>"$todo"
1154 git_sequence_editor "$todo" ||
1155 die "$(gettext "Could not execute editor")"
1156 expand_todo_ids
1158 exit
1160 esac
1162 comment_for_reflog start
1164 if test ! -z "$switch_to"
1165 then
1166 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
1167 output git checkout "$switch_to" -- ||
1168 die "$(eval_gettext "Could not checkout \$switch_to")"
1170 comment_for_reflog start
1173 orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
1174 mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
1176 : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
1177 write_basic_state
1178 if test t = "$preserve_merges"
1179 then
1180 if test -z "$rebase_root"
1181 then
1182 mkdir "$rewritten" &&
1183 for c in $(git merge-base --all $orig_head $upstream)
1185 echo $onto > "$rewritten"/$c ||
1186 die "$(gettext "Could not init rewritten commits")"
1187 done
1188 else
1189 mkdir "$rewritten" &&
1190 echo $onto > "$rewritten"/root ||
1191 die "$(gettext "Could not init rewritten commits")"
1193 # No cherry-pick because our first pass is to determine
1194 # parents to rewrite and skipping dropped commits would
1195 # prematurely end our probe
1196 merges_option=
1197 else
1198 merges_option="--no-merges --cherry-pick"
1201 shorthead=$(git rev-parse --short $orig_head)
1202 shortonto=$(git rev-parse --short $onto)
1203 if test -z "$rebase_root"
1204 # this is now equivalent to ! -z "$upstream"
1205 then
1206 shortupstream=$(git rev-parse --short $upstream)
1207 revisions=$upstream...$orig_head
1208 shortrevisions=$shortupstream..$shorthead
1209 else
1210 revisions=$onto...$orig_head
1211 shortrevisions=$shorthead
1213 format=$(git config --get rebase.instructionFormat)
1214 # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
1215 git rev-list $merges_option --format="%m%H ${format:-%s}" \
1216 --reverse --left-right --topo-order \
1217 $revisions ${restrict_revision+^$restrict_revision} | \
1218 sed -n "s/^>//p" |
1219 while read -r sha1 rest
1222 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1223 then
1224 comment_out="$comment_char "
1225 else
1226 comment_out=
1229 if test t != "$preserve_merges"
1230 then
1231 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1232 else
1233 if test -z "$rebase_root"
1234 then
1235 preserve=t
1236 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1238 if test -f "$rewritten"/$p
1239 then
1240 preserve=f
1242 done
1243 else
1244 preserve=f
1246 if test f = "$preserve"
1247 then
1248 touch "$rewritten"/$sha1
1249 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1252 done
1254 # Watch for commits that been dropped by --cherry-pick
1255 if test t = "$preserve_merges"
1256 then
1257 mkdir "$dropped"
1258 # Save all non-cherry-picked changes
1259 git rev-list $revisions --left-right --cherry-pick | \
1260 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1261 # Now all commits and note which ones are missing in
1262 # not-cherry-picks and hence being dropped
1263 git rev-list $revisions |
1264 while read rev
1266 if test -f "$rewritten"/$rev &&
1267 ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1268 then
1269 # Use -f2 because if rev-list is telling us this commit is
1270 # not worthwhile, we don't want to track its multiple heads,
1271 # just the history of its first-parent for others that will
1272 # be rebasing on top of it
1273 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1274 sha1=$(git rev-list -1 $rev)
1275 sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1276 rm "$rewritten"/$rev
1278 done
1281 test -s "$todo" || echo noop >> "$todo"
1282 test -n "$autosquash" && rearrange_squash "$todo"
1283 test -n "$cmd" && add_exec_commands "$todo"
1285 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
1286 todocount=${todocount##* }
1288 cat >>"$todo" <<EOF
1290 $comment_char $(eval_ngettext \
1291 "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
1292 "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
1293 "$todocount")
1295 append_todo_help
1296 gettext "
1297 However, if you remove everything, the rebase will be aborted.
1299 " | git stripspace --comment-lines >>"$todo"
1301 if test -z "$keep_empty"
1302 then
1303 printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
1307 has_action "$todo" ||
1308 return 2
1310 cp "$todo" "$todo".backup
1311 collapse_todo_ids
1312 git_sequence_editor "$todo" ||
1313 die_abort "$(gettext "Could not execute editor")"
1315 has_action "$todo" ||
1316 return 2
1318 check_todo_list
1320 expand_todo_ids
1322 test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
1324 checkout_onto
1325 if test -z "$rebase_root" && test ! -d "$rewritten"
1326 then
1327 require_clean_work_tree "rebase"
1328 exec git rebase--helper ${force_rebase:+--no-ff} --continue
1330 do_rest
1333 # ... and then we call the whole thing.
1334 git_rebase__interactive